/*  The feeling I've tried to picture is a combination of good (light, warmth
    peace, joy, contentment, happiness etc) with the cool calculating 
    organizaton of law.  Lawful Good is the organized effort to rid the world
    of evil.  Striving for good with a purpose.  (I don't think I like this
    room descrip.  If you have any ideas, PLEASE let me know.)

    Guilo Forgebane             [The Bearded One]
*/

inherit "/std/sacroom";

void setup()  {

  set_light(80);
  add_property("no_clean_up",1);

  set_short("The Cathedral of Lawful Good.");

  set_long("\nThe Cathedral of Lawful Good:  Mosque of Peace and Order.\n\n"
           "   You have entered a large hall octagonal in shape made from "
           "roughly hewn stone blocks.  On each of the eight walls there "
           "are two large, open-air windows allowing sunlight into the hall "
           "carried on a light, warm breeze.  Fountains standing in each "
           "corner spray water in colorful arcs and add a soft murmer to "
           "the sounds of the breeze.  Huge tapestries adorn each wall "
           "depicting acts of honor, bravery, and loyalty among others.  "
           "Everything about this place seems sacred and you get the feeling "
           "that not even an evil thought would be known here.  In the center "
           "of this hall is a stone altar that radiates its own light.\n"
           "\n");

  add_smell(({"breeze"}),
            "\n   The soft fragrance of wildflowers tempered with the tang "
            "of cold steel and stone seems oddly familiar to you.  Memories "
            "of a childhood long forgotten begin to swim to the surface of "
            "your conciousness.\n"
            "\n");

  add_feel(({"light","breeze"}),
           "\n   The light streaming through the open-air windows is warm "
           "and perfectly complimented by the cooling breeze wafting into "
           "the room.   Their combination creates a soothing effect that "
           "helps to calm the nerves and focus the mind.\n"
           "\n");

  add_sound(({"breeze","water","fountain","fountains"}),
            "\n   The breeze carries the soft sounds of birds singing and "
            "children laughing.  The soft murmur of the water from the "
            "fountains creates an almost hypnotic rhythm.  Peace fills "
            "your mind and helps you to focus on the virtues of good.\n"
            "\n");

  add_item(({"block","stone block","blocks","stone blocks"}),
           "\n   The stone blocks of this hall have been hewn from the "
           "purest of marble interspersed with veins of gold and quartz.  "
           "Although roughly cut, the stones fit together perfectly and "
           "the seams are almost invisible.\n"
           "\n");

  add_item(({"window","windows"}),
           "\n   The windows of the hall must stand nearly eight feet tall "
           "and are open to the world around.  Bright sunlight and a "
           "cool breeze stream through the windows adding warmth and a "
           "sense of peace to the hall.\n"
           "\n");

  add_item(({"light","sunlight"}),
           "\n   The sunlight is warm and bright and it reflects off the "
           "marble walls adding to the overall glow of the room.  Power "
           "hums through the stone in harmony to the fountains.\n"
           "\n");

  add_item(({"fountain","fountains"}),
           "\n   There are eight fountains in each of the eight corners of "
           "the room.  Although the fountains are not very ornate or "
           "decorative, they have a simple beauty that draws you in.  You "
           "can't help but stare and wonder at the talent of their "
           "creator.  Each fountain tries to depict a different quality "
           "by combining shape and color.\n"
           "\n");

  add_item(({"tapestry","tapestries"}),
           "\n   The tapestries are truly magnificent.  Honor, Valor, "
           "Honesty, Love, Peace, Truth, Virtue, and Law are all depicted "
           "in colors and designs of the caliber never seen before.  Each "
           "tapestry also pays homage to Virga, the Goddess of this "
           "Cathedral.\n"
           "\n");

  set_god_here("virga");
  add_exit("west","/d/sf/areas/haisk/ws_str1","door");
}  /* setup */
