// /global/creator/cmds/ls.c  --  does an ls

#include <standard.h>
#include <cmd.h>

inherit CMD_BASE;

void setup()
{
position = CREATOR_CMD;
}

string query_usage()
{
  return "[directory|filename]";
}

string query_short_help()
{
  return "List files in current or specified directories";
}

string dir_entry(string path, string fname)
{
  int size;
  string *obs;
  string name;

  name = fname;

  size = file_size(path+name);
  if (size == -2) {
    obs = get_dir(path+name+"/");
    if (!obs)
      size = -1;
    else
      size = sizeof(obs);
    name += "/";
  } else {
    if (virtual_find_object(path+name))
      name = "*"+name;
    size = (size / 1024) + 1;
  }
  if (size < 1000)
    return sprintf("%s%d %s", "    "[0..3-strlen(size+"")], size, name);
  return size+" "+name;
}
 
static int cmd(string str, object me)
{
  string *direc, *bit;
  string bing;
  int max_siz, i, size;
 
  if(!str || str=="")
    str = (string)TP->query_path();
  str = (string)TP->get_path(str);
 
  if (file_size(str) == -2 && str[strlen(str)-1] != '/')
    str += "/";

  direc = get_dir(str);
  if (!direc || !sizeof(direc))
  {
    write("No files.\n");
    return 1;
  }

  if (file_size(str) == -2)
  {
    if (str[strlen(str)-1] != '/')
      str += "/";
  }
  else
  {
    bit = explode(str, "/");
    bit = bit[0..sizeof(bit)-2];
    str = "/"+implode(bit,"/")+"/";
  }

  if(str == "//")
    str = "/";

  write("Dir of: "+str+"\n");
     
  bing = "";
  for (i=0; i<sizeof(direc); i++)
  {
    if (strlen(direc[i]) > 30)
    {
      write(dir_entry(str, direc[i])+"\n");
      direc = delete(direc, i, 1);
      i--;
      continue;
    }
    else
    {
      bing += dir_entry(str, direc[i])+"\n";
    }
  }
 
  printf("%#-*s\n", TP->query_cols(), bing);
  return 1;
}
