// bury cmd from player.c. Made external by Morgoth 2/Mar/95
// extended so it can bury any nonliving, droppable, gettable object

#include <standard.h>
#include <cmd.h>

inherit CMD_BASE;

void setup()
{
	position = 0;
}

string query_usage()
{
	return "bury [<objects>]";
}

string query_short_help()
{
	return "Buries the specified objects; by default will bury any corpses";
}

static int cmd (string str, object me)
{
	object *target, *live, *unable, *buried, here;
	int counter,i;

	here = environment(me);
  	counter = 0;
	if (!str || str == "")
	{
		target = all_inventory(here); 
		for (i=0;i<sizeof(target);i++) 
			if(target[i]->query_corpse() &&
				(string)target[i]->query_name() == "corpse")
			{ 
				target[i]->dest_me();
				counter++;
			}
		if (counter)
			write("You bury the corpse"+(counter == 1?"":"s")+
				" deep within the earth.\n");
		else
			notify_fail("You can't find any corpses!\n");
		return counter;
	}
	else
	{
		if (me->expand_nickname(str)
			==me->query_name())
		{
			write ("Burying yourself?\n");
			return 1;
		}
		live = unable = buried = ({ });
		target = find_match(str, here) - ({me});
		if (!sizeof(target))
		{
			notify_fail("Bury what?\n");
			return 0;
		}
		for (i=0;i<sizeof(target);i++)
		{
			if (living(target[i]))
				live += ({target[i]});
			else
			if(target[i]->drop() || target[i]->get())
				unable += ({target[i]});
			else
				buried += ({target[i]});
		}
		if (sizeof (buried))
		{
			write ("You bury "+query_multiple_short(buried)+
				" deep within the earth.\n");
			say (me->query_cap_name()+ " buries "+
				query_multiple_short(buried)+
				" deep within the earth.\n");
			for (i=0;i<sizeof(buried);i++)
				buried[i]->dest_me();
		}
		if (sizeof (unable))
			write ("You try hard to bury "+
				query_multiple_short(unable)+", but "+
					"must eventually give up.\n");
		if (sizeof (live))
			write (capitalize(query_multiple_short(live))+
				(sizeof(live)==1? " doesn't" : " don't") +
				" feel like being buried right now. "+
				"Maybe later.\n");
		return 1;
	}
}
