// consider cmd from player.c. Made external by Morgoth 3/Mar/95

#include <standard.h>
#include <cmd.h>

inherit CMD_BASE;

void setup()
{
	position = 0;
}

string query_usage()
{
	return "consider <target>";
}

string query_short_help()
{
	return "Shows a level based estimation of how tough is an enemy";
}

static int cmd (string str, object me)
{
	object *obs;
	int level, i, ok, dif;

	if (!str)
	{
		notify_fail("Syntax: consider <monster>\n");
		return 0;
	}
	obs = find_match(str, environment(me));
	if (!sizeof(obs))
	{
		notify_fail("You need to consider someone who exists.\n");
		return 0;
	}
	level = me->query_level();
	for (i=0;i<sizeof(obs);i++)
	{
		if (!living(obs[i]))
			continue;
		ok = 1;

	// Added by Ink to stop all those silly questions
		if (obs[i]->query_creator())
		{
			write("You would be struck down if you attacked the "+
				"Immortal "+obs[i]->query_cap_name()+".\n");
			continue;
		}
		dif = (int)obs[i]->query_level() - level;
		if (dif > 100)
		{
			write("You would have to be utterly insane to attack "+
				obs[i]->short()+".\n");
			continue;
		}
		if (level > 5)
		{
			dif /= 5;
			if (dif > 2 || dif < -2)
				dif /= 2;
			if (dif > 5)
				dif = 5;
			if (dif < -5)
				dif = -5;
			dif += 5;

			write(obs[i]->short()+({
				" is too weak to bother attacking.\n",
				" is some one you look down on.\n",
				" is a lot weaker than you are.\n",
				" is weaker than you are.\n",
				" is slightly weaker than you are.\n",
				" is about equal with you.\n",
				" is about equal with you.\n",
				" is about equal with you.\n",
				" is slightly tougher than you are.\n",
				" is tougher than you are.\n",
				" is a lot tougher than you are.\n",
				" looks pretty nasty.\n",
				" is into don't think about it region.\n"
			})[dif]);
		}
		else
		if (dif < 0)
			write(obs[i]->short()+" would be an easy target.\n");
		else
		{
			dif /= 2;
			if (dif > 5)
				dif = 5;
			write(obs[i]->short()+({ " is about equal with you.\n",
				" is slightly tougher than you are.\n",
				" is tougher than you are.\n",
				" is a lot tougher than you are.\n",
				" looks pretty nasty.\n",
				" is into don't think about it region.\n"
			       })[dif]);
		}
	}
	if (!ok)
	{
		notify_fail("It helps if you consider attacking something "+
			"that is alive.\n");
		return 0;
	}
	return 1;
}
