// glance cmd from player.c, now external. Morgoth 2/Mar/95

#include <standard.h>
#include <cmd.h>

inherit CMD_BASE;

void setup()
{
	position = 0;
}

string query_usage()
{
	return "glance [at <object>]";
}

string query_short_help()
{
	return "Returns short description of an object or (default) the "+
		"place where you are.";
}


static int cmd (string arg, object me)
{
	object here, *ob;
	int i, dark;
	string ret;

	me = me;
	here = environment(me);

	if (!here)
	{
		notify_fail("You are in limbo... sorry you can't look at "+
				"anything.\n");
		return 0;
	}
	dark = me->check_dark((int)here->query_light());
	if (!arg)
	{
		if (me->query_creator())
			tell_object(me,file_name(here)+"\n");
		if(!dark)
			ret = (string)here->query_contents();
		else
			ret = "";
		tell_object(me,(string)here->short(dark, 1)+ ".\n" + ret);
		return 1;
	}
	if (!sscanf(arg, "at %s", arg))
	{
		notify_fail("Glance at something!\n");
		return 0;
 	}

	ob = find_match (arg, ({ me, here }) );

	if (sizeof(ob))
	{
		for (i=0;i<sizeof(ob);i++)
		tell_object(me,ob[i]->short(dark)+".\n");
		return 1;
	}

	notify_fail("You do not think that the "+arg+" is here.\n");
	return 0;
}

