/* The player sheet from the Final Realms mud, pasted in by Baldrick.
 * 26 sept '93
 */

// Converted to the new command handler system by Morgoth 1/Mar/95
// - cleaned the code a bit :)
// - fixed 'money carried' to show the right amount
// - changed it to use query_al instead of query_alignment, was
//   showing wrong values.

#include <standard.h>
#include <cmd.h>

inherit CMD_BASE;

void setup()
{
	position = 0;
}

string query_usage()
{
	return "sheet";
}

string query_short_help()
{
	return "Returns misc information and stats on a player.";
}

static int cmd (string str, object me)
{
	int i;
	string info;
	object guild;

	guild = me->query_guild_ob();

	info = "";
	info += "Name : "+me->query_cap_name()+"\n";
	info += "Race : "+me->query_race()+"\n";
	info += "Sex  : "+me->query_gender_string()+"\n";
	if (guild)
   		info += "Guild: "+guild->query_short()+"\n";
	else
		info += "Guild: No guild.\n";
	if (me->query_creator())
	{
		info += "Height: "+me->query_height()+"\n";
		info += "Weight: "+me->query_weight()+"\n";
		info += "Alignment: "+me->query_al();
		if (me->query_alignment())
			info += " ("+me->query_alignment()+")\n";
		else
			info += "\n";
	}
	if(guild)
		info += "Level: "+guild->query_level(me)+"\n";
	else
		info += "Level: "+me->query_skill("fighting")+"\n";
	info += "Wimpy: "+me->query_wimpy()+" %\n";
	info += "Strength      : "+me->stat_string(me->query_str())+"\n";
	info += "Dexterity     : "+me->stat_string(me->query_dex())+"\n";
	info += "Constitution  : "+me->stat_string(me->query_con())+"\n";
	info += "Intelligence  : "+me->stat_string(me->query_int())+"\n";
	info += "Wisdom        : "+me->stat_string(me->query_wis())+"\n";
	info += "Hit Points    : "+me->query_hp()+" ("+me->query_max_hp()+")\n";
	info += "Guild Points  : "+me->query_gp()+" ("+me->query_max_gp()+")\n";
	info += "Social        : "+me->query_social_points()+" ("+
					me->query_max_social_points()+")\n";
	info += "Money carried : "+me->query_value()/1000+" GP\n";
	info += "Experience    : "+me->query_xp()+"\n";
	info += "Encumbrance   : "+me->query_loc_weight()+
					" ("+me->query_max_weight()+")\n";
	info += "Deaths        : "+me->query_deaths()+
					" ("+me->query_max_deaths()+")\n";
	printf("%-#*s\n", me->query_cols(), info);
	write("\n");
// Minor fix    -Aragorn
	me->show_spells("");
	me->list_commands();
	return 1;
}
